//
// Created by webpigeon on 17/04/22.
//

#ifndef FGGL_GFX_OGL4_MODELS_HPP
#define FGGL_GFX_OGL4_MODELS_HPP

#include <string>
#include <unordered_map>

#include "fggl/gfx/ogl/backend.hpp"
#include "fggl/ecs3/ecs.hpp"

namespace fggl::gfx::ogl4 {

	class StaticModelRenderer {
		public:
			StaticModelRenderer() = default;
			~StaticModelRenderer() = default;

			StaticModelRenderer(const StaticModelRenderer& other) = delete;
			StaticModelRenderer(StaticModelRenderer&& other) = delete;

			StaticModelRenderer& operator=(const StaticModelRenderer& other) = delete;
			StaticModelRenderer& operator=(StaticModelRenderer&& other) = delete;

			void render(ecs3::World& world) {
				resolveModels(world);
				renderModelsForward(world);
			}

		private:
			/**
			 * Attach any missing rendering components to models.
			 */
			void resolveModels(ecs3::World& world);

			/**
			 * Render all visible objects according to their render tokens.
			 */
			void renderModelsForward(const ecs3::World& world);

			std::unordered_map<std::string, std::shared_ptr<gfx::Shader>> m_shaders;
	};

}

#endif //FGGL_GFX_OGL4_MODELS_HPP
